/*===================================================

run with corr1.dat and options

--mostf --bestb
or
--mostf --bestb --cuts
or
--mostf --bfs
or
--mostf --bfs --cuts

terminates with error

Assertion failed: ptr < end
Error detected in file ..\src\bflib\sgf.c at line 146


run with corr2.dat and options

--pcost --bestp

or

corr3.dat and options

--drtom --bestp
or
--pcost --bestp
or
--pcost --dfs

terminates with error

Assertion failed: piv1 != 0.0
Error detected in file ..\src\glpspx02.c at line 3026

===================================================*/

set	M_;
set	A_{M_};
param	u{M_};
param	c{M_};

set	R := {i in M_ : u[i] = 0 and c[i] = 0};
set	I := {i in M_ : u[i] = 0 and c[i] <> 0};
set	M := M_ diff I;
set	A{i in M} := A_[i] diff I;

set	N := {i in M, A[i]};
set	N_ := setof{(i,j) in N} (j,i);
check	N within N_;

param	i0 := max{i in R} i;

var	x{N} integer >= 0;
var	y{M} binary;

minimize f	: sum{i in M} c[i] * y[i];

r1{i in M}	: sum{j in A[i]} (x[i,j] - x[j,i])  =
		  if i = i0 then sum{j in M} y[j] - 1 else -y[i];

r2{i in M}	: sum{j in A[i]} (x[i,j] + x[j,i])  <=  y[i] * card(M) * 2;

r3{i in R}	: y[i]  =  1;

r4		: sum{j in A[i0]} x[j,i0]  =  0;

solve;

display f, {i in M : y[i] = 1};

end;
