/*===================================================

run with option

--cuts

terminates with error

Assertion failed: piv1 != 0.0
Error detected in file ..\src\glpspx02.c at line 3027

===================================================*/

set	R;
set	S;
set	T;
set	W;

param	d;
set	D := setof{g in 0..d} g / d;

param	rp{R};
param	ri{R};
param	rc{R};
param	so{S};
param	sf{S};
param	sp{S};
param	to{T};
param	tf{T};
param	tp{T};
param	wc{W};
param	wp{W};

param	op;
param	an;
param	un;
param	ep;
param	c;

param	f1 := sum{i in S} sf[i];
param	f2 := sum{i in S} sp[i] * sf[i];

var	xst{S,T} >= 0;
var	xsr{S,R} >= 0;
var	xse{S} >= 0;
var	xrt{R,T,D} >= 0;
var	xrt_{R,T,D} >= 0;
var	xwt{W,T} >= 0;

var	xr{R} >= 0;
var	xr_{R} >= 0;

var	yst{S,T} binary;
var	ysr{S,R} binary;
var	yrt{R,T} binary;

var	z{R,T,D} binary;

minimize f		: op * sum{k in W, j in T} wc[k] * xwt[k,j] +
			  an * sum{h in R} ri[h] * c * xr[h] +
			  op * sum{i in S, h in R} rc[h] * rp[h] * sp[i] * xsr[i,h] / 1000 +
			  an * un * sum{i in S, j in T : so[i] <> to[j]} yst[i,j] +
			  an * un * sum{i in S, h in R} ysr[i,h] +
			  an * un * sum{h in R, j in T} yrt[h,j];

r1{i in S}		: sum{j in T} xst[i,j] + sum{h in R} xsr[i,h] + xse[i]  =  sf[i];
r2{h in R}		: xr[h]  =  sum{j in T, g in D} xrt[h,j,g];
r3{j in T}		: sum{i in S} xst[i,j] + sum{h in R, g in D} xrt[h,j,g] +
					sum{k in W} xwt[k,j]  =  tf[j];

r4{j in T}		: sum{i in S} sp[i] * xst[i,j] + sum{h in R, g in D} xrt_[h,j,g] +
					sum{k in W} wp[k] * xwt[k,j]  <=  tp[j] * tf[j];

r5			: sum{i in S} sp[i] * xse[i]  <=  ep * sum{i in S} xse[i];

r6{i in S, j in T}	: xst[i,j]  <=  yst[i,j] * sf[i];
r7{i in S, h in R}	: xsr[i,h]  <=  ysr[i,h] * sf[i];
r8{h in R, j in T}	: sum{g in D} xrt[h,j,g]  <=  yrt[h,j] * f1;

r9{h in R}		: xr[h]  =  sum{i in S} (1 - rp[h] * sp[i] * 1e-6) * xsr[i,h];
r10{h in R}		: xr_[h]  =  (1 - rp[h]) * sum{i in S} sp[i] * xsr[i,h];

r11{h in R, j in T, g in D}	: xrt[h,j,g]  <=  g * xr[h];
r12{h in R, j in T, g in D}	: xrt[h,j,g]  <=  z[h,j,g] * f1;
r13{h in R, j in T, g in D}	: g * xr[h] - xrt[h,j,g]  <=  (1 - z[h,j,g]) * f1;

r14{h in R, j in T, g in D}	: xrt_[h,j,g]  <=  g * xr_[h];
r15{h in R, j in T, g in D}	: xrt_[h,j,g]  <=  z[h,j,g] * f2;
r16{h in R, j in T, g in D}	: g * xr_[h] - xrt_[h,j,g]  <=  (1 - z[h,j,g]) * f2;

r17{h in R, j in T}	: sum{g in D} z[h,j,g]  <=  1;

data;

param	op 8000;
param	an 0.231;
param	un 50000;
param	ep 90;
param	c 0.14;
param	d 2;

param :	W :	wp	wc :=
	1	0	0.13
	2	10	0.11;

param :	R :	rp	ri	rc :=
	1	0.1	500	0.540
	3	0.3	9200	0.850
	5	0.5	11300	1.160;

param :	S :	so	sf	sp :=
	2	1	80	110
	4	2	130	125
	5	2	60	95
	6	2	110	140
	7	3	95	120
	8	3	115	115
	9	3	140	100;

param :	T :	to	tf	tp :=
	1	1	80	70
	2	1	120	80
	3	1	100	100
	4	2	130	90
	5	2	90	110
	7	3	110	115
	8	3	160	85;

end;
